;(function($){
    // 防抖
    function debounce(func, wait, ctx) {
        var timeout;
        return function () {
            var context = ctx;
            var args = arguments;

            if (timeout) clearTimeout(timeout);

            timeout = setTimeout(function () {
                func.apply(context, args)
            }, wait);
        }
    }
    // 数字滚动的类
    function ScrollNum(dom, delay, num, dir, trigger){
        this.dom = dom;
        this.delay = delay;
        this.num = num;
        this.dir = dir;
        this.trigger = trigger;
    }
    ScrollNum.prototype.listen = function () {
        // 手动
        if (this.trigger == 'manual') {
            this.dom.data('done', true)
            this.dom.parent().parent().data('done', true)
            this.beginMove()
        } else { // 自动
            var vm = this;
            setTimeout(function(){
                vm.positionAdjust();
            }, 1000)
            // $(window).on('scroll', function () {
            //     vm.positionAdjust()
            // })
            $(window).on('scroll', debounce(vm.positionAdjust, 100, vm))
        }
    }
    ScrollNum.prototype.positionAdjust = function (){
        if (this.dom.data('done')) {
            return;
        }
        if (this.dom.offset().top - $(document).scrollTop() < $(window).height() - 50) {
            this.dom.data('done', true)
            this.dom.parent().parent().data('done', true)
            this.beginMove()
        }
    }
    ScrollNum.prototype.beginMove = function () {
        const vm = this;
        setTimeout(function(){
            vm.move()
        }, this.delay * 200)
    }
    ScrollNum.prototype.move = function (){
        const _this = this;
        var round = 1;
        var targetNum = _this.num; // 显示数字7

        var numHeight = Math.floor(_this.dom.parent().siblings('.c-num__original').height()); // 一个数字的高度
        var desHeight = targetNum * numHeight;  // 最后一圈的位置
        var oneRoundHeight = numHeight * 10;
        
        var curPos = _this.dir == 'up' ? 0 : oneRoundHeight; // 初始位置
        var roundCount = 0;
        var duration = 2000;
        var interval = 15;  // 循环间隔
        var increment = 1;
        if (_this.dir == 'up') {
            increment = (round * oneRoundHeight + desHeight) / (duration / interval);
        } else {
            increment = (round * oneRoundHeight + oneRoundHeight - desHeight) / (duration / interval);
        }
        if (increment < 1) {
            increment = 1
        }
        $(window).resize(function(){
            numHeight = Math.floor(_this.dom.parent().siblings('.c-num__original').height());
            _this.dom.parent().css({
                'line-height': numHeight + 'px',
                'height': numHeight + 'px'
            })
            desHeight = targetNum * numHeight;  // 最后一圈的位置
            _this.dom.css('transform', 'translateY(' + -1 * desHeight + 'px)')
            _this.dom.parent().parent().css('min-width', _this.dom.parent().width())
        })

        // 设置初始位置
        _this.dom.css('transform', 'translateY(' + curPos + 'px)')
        // 开始滚动
        var timer = setInterval(function(){
            if (_this.dir == 'up') {
                curPos += increment;
                if (curPos >= oneRoundHeight) {
                    roundCount++;
                    curPos = 0;
                }
            } else {
                curPos -= increment;
                if (curPos <= 0) {
                    roundCount++;
                    curPos = oneRoundHeight;
                }
            }
            
            _this.dom.css('transform', 'translateY(' + -1 * curPos + 'px)')
            if (_this.dir == 'up') {
                if (roundCount == round && curPos >= desHeight) {
                    clearInterval(timer)
                    _this.dom.css('transform', 'translateY(' + -1 * desHeight + 'px)')
                }
            } else {
                if (roundCount == round && curPos <= desHeight) {
                    clearInterval(timer)
                    _this.dom.css('transform', 'translateY(' + -1 * desHeight + 'px)')
                }
            }
        }, interval)
    }
    $.fn.numScroll = function(options){
        options = options || {}
        var $this = this;
        var dir = 'up';
        if (options.dir == 'up' || options.dir == 'down') { // 有效值
            dir = options.dir
        }
        $this.each(function(i, el){
            if ($(el).data('done')) {
                return;
            } else {
                $(el).data('done', true)
            }
            var nums = $(el).text().split('').map(function(item){
                var temp = Number(item)
                if (isNaN(temp)) {
                    return item
                } else {
                    return temp
                }
            })
            if (nums.every(function(item){  // 所有的字都不是数字，就返回
                return isNaN(item)
            })){
                console.log('格式错误');
                return
            }
            if (isNaN(nums[0])) { // 第一个字不是数字类型，就返回
                return
            }
            var $original = $('<p class="c-num__original" style="opacity: 0">' + $(el).text() + '</p>')
            var $num_wrap = $('<div class="c-num"></div>')
            $(el).html('').append($original).append($num_wrap)
            var numHeight = Math.floor($original.height()); // 一个数字的高度
            $num_wrap.css({
                display: 'flex',
                overflow: 'hidden',
                position: 'absolute', 
                left: 0,
                top: '50%',
                transform: 'translateY(-50%)',
                'text-align': 'center',
                'line-height': numHeight + 'px',
                'height': numHeight + 'px'
            })
            for (var ii = 0; ii < nums.length; ii++) {
                if (isNaN(nums[ii])) {  // 不是数字，就直接原样显示，主要是兼容小数点符号
                    $num_wrap.append($('<div>' + nums[ii] + '</div>'))
                } else {
                    var $num_item = $('<div class="c-num__item"></div>')
                    // 加每列数字
                    for (var j = 0; j < 11; j++) {
                        var $num = $('<p></p>')
                        $num.text(j.toString().slice(-1))
                        $num_item.append($num)
                    }
                    $num_wrap.append($num_item)
                    new ScrollNum($num_item, ii, nums[ii], dir, options.trigger).listen()
                }
            }
            setTimeout(function(){
                $(el).css({
                    position: 'relative',
                    'min-width': $num_wrap.width()
                })
            }, 100)
        })
    }
})(jQuery);
